#include<stdio.h>
#include<stdlib.h>
#include<stdbool.h>
#include<string.h>

#define LENGTH 500

struct fifo_node {
    char data[LENGTH];
    struct fifo_node *next;
};

struct fifo_pointers {
    struct fifo_node *head, *tail;
} fifo;

void copy_string(char *destination, char *source)
{
    strncpy(destination,source,LENGTH-1);
    destination[LENGTH-1] = '\0';
}

bool enqueue(struct fifo_pointers *fifo, char *data)
{
    struct fifo_node *new_node = (struct fifo_node *)malloc(sizeof(struct fifo_node));
    if(new_node) {
        copy_string(new_node->data,data);
        new_node->next = NULL;
        if(fifo->head == NULL && fifo->tail == NULL) {
            fifo->head = fifo->tail = new_node;
        } else {
            fifo->tail->next = new_node;
            fifo->tail = new_node;
        }
        return true;
    } else
        return false;
}

bool dequeue(struct fifo_pointers *fifo, char *data)
{
    if(fifo->head) {
        struct fifo_node *temporary = fifo->head->next;
        copy_string(data,fifo->head->data);
        free(fifo->head);
        fifo->head = temporary;
        if(temporary == NULL)
            fifo->tail = NULL;
        return true;
    }
    return false;
}


int main(int argc, char *argv[])
{
    for(int i=0; i<argc; i++)
        if(!enqueue(&fifo, argv[i]))
            printf("Argument: %s nie został dodany do kolejki!",argv[i]);
    while(fifo.head) {
        char string[LENGTH];
        if(dequeue(&fifo,string))
            printf("Dane z kolejki: %s\n", string);
    }
    return 0;
}
